//
// Created by anderlim on 08.11.16.
//

//TODO: change to 1 - X when inverting

/*
 * C Program to Find the Length of the Longest Repeating Sequence in a String
 */
#include "cgp.h"
#include <math.h>
#include <stdio.h>
#include "./parityFitness.h"
#include "fitnessFunctions.h"

#define RUNS 100
#define WARMUP 0
#define LIMIT 100.0
double clamp(double x, double limit);
double getSMRate(struct chromosome *chromo);



double computationalFitness(struct parameters *params, struct chromosome *chromo, struct dataSet *data) {
    struct chromosome* testChromo = initialiseChromosomeFromChromosome(chromo);
    saveChromosome(testChromo, "test.chr");
    char* argv[3] = {"","run_train","run"};
    double developmental = 1.0;
    double separation = 1.0;
    double accuracy = 0.0;
    double smRate = 0.0;

//    static int cnt = -1;
//    if(chromo->generation % 100 == 0 && cnt != chromo->generation ) {
//        setMutationRate(params, params->mutationRate/2);
//        cnt = chromo->generation;
//    }

#pragma omp parallel sections
    {
#pragma omp section
        //if(chromo->generation < 500)
        {
            developmental = 100.0 * developmentalFitness(params, testChromo, data) + 1.0;
        }//else
#pragma omp section
        {
            separation = 100.0 * separationProperty(params, testChromo, data, 30) + 1.0;
        }
//#pragma omp section
        //{
            //accuracy = 100.0 * parityFitness(3, argv);
        //}
#pragma omp section
        {
            smRate = 100 * fabs(getSMRate(chromo)-0.1) + 1.0;
        }
    }
    double fadingMem = 0.0;//fadingMemory(chromo, data) * 100.0;
    double compFitness = separation - fadingMem;
    //if(compFitness < 0.0) return 100000.0;
    double active = 0.0;//activeFitness(chromo);
    double fitness =  developmental + separation;
    //double fitness = ((developmental)+(100.0-accuracy)+(100.0-compFitness))/1200.0+active*100.0;

    FILE *fpRes;
    fpRes = fopen("exp11/Fit.txt", "a+");
    if(chromo->generation<10000)
        fprintf(fpRes,"%d,%f,%f,%f,%f,%f\n",chromo->generation,separation,developmental,accuracy,smRate,fitness);
    fclose(fpRes);
    printf("\033[1A sep:%05.3f\t| acc:%01.3f  | active:%01.3f  | dev:%01.3f  | smr:%01.3f  |  tot:%03.5f \n",separation,accuracy,active,developmental, smRate, fitness);
    if(accuracy==100.0) return 0.0;
    return fitness;

}

double separationProperty(struct parameters *params, struct chromosome *chromo, struct dataSet *data, int tau){

    int runs = params->numAverage;
    int devRuns = params->numDevRuns;

    int numSamples = getNumDataSetSamples(data)/10;

    if(numSamples>250) numSamples = 250; //Limit number of iterations to save cpu

    double input;
    int numNodes = 200;//getNumChromosomeNodes(chromo);

    double resultA[numSamples][numNodes];
    double resultB[numSamples][numNodes];

    double result = 0.0;
    double one = 1.0;

    int i, j;

    struct chromosome* currentChromo;
    //printf("samples: %d, nodes: %d,\n", numSamples, numNodes);

//#pragma omp parallel for default(none), \
    shared(chromo, data, runs, params, devRuns, numSamples, numNodes, tau), \
    private(i, currentChromo, one, input, resultA, resultB ), \
    schedule(guided, runs/params->numThreads), \
    num_threads(params->numThreads), reduction(+:result)
    for(j = 0; j < runs; j++) {

        double temp;
        int n = 0;

        currentChromo = initialiseChromosomeFromChromosome(chromo);

//        while (n < devRuns/2) {
//            currentChromo = executeChromosome(currentChromo, getDataSetSampleInputs(data, n));
//            n++;
//        }
        for (int i = 0; i < numSamples; i++) {

            //input = getDataSetSampleInputs(data, i);
            //printf("A: iter:%d,input:%f\n", i, input);
            currentChromo = executeChromosome(currentChromo, getDataSetSampleInputs(data, i));

            for (int j = 0; j < numNodes; j++) {
                temp = getChromosomeNodeValue(currentChromo, j);
                //if(temp > LIMIT || temp < -LIMIT)
                //    return 0.0;
                //temp = clamp(temp, LIMIT);
                resultA[i][j] = temp;
            }
        }

        resetChromosome(currentChromo);
        n = 0;
//        while (n < devRuns) {
//            currentChromo = executeChromosome(currentChromo, &one);
//            n++;
//        }
        for (int i = 0; i < numSamples; i++) {

            input = getDataSetSampleInput(data, i, 0);
            //invert input if i<tau
            if (i < tau) {
                if (input == 1.0) input = 0.0; else input = 1.0;
            }
            //printf("B: iter:%d,input:%f\n", i, input);
            currentChromo = executeChromosome(currentChromo, &input);

            for (int j = 0; j < numNodes; j++) {
                temp = getChromosomeNodeValue(currentChromo, j);
                //printf("%f ", result[i]);
                //if(temp > LIMIT || temp < -LIMIT)
                 //   return 0.0;
                //temp = clamp(temp, LIMIT);

                resultB[i][j] = temp;
            }
        }

        for (int i = 0; i < numSamples; i++) {
            for (int j = 0; j < numNodes; j++) {
                //double temp= fabs(clamp((resultA[i][j] - resultB[i][j])/100.0, 1.0));
                //printf("%f\n",temp);
                result += resultA[i][j] == resultB[i][j] ? 1.0 : 0.0;
            }
        }
    }

//    if(result>numNodes*numSamples*runs){
//        printf("Error result too big:%f\n",result);
//        return 0.0;
//    }

    return result/(numNodes*numSamples*runs);

}

double getSMRate(struct chromosome *chromo){
    int sum = 0;
    for(int i = 0; i<chromo->numNodes; i++){
        sum+= chromo->smNodes[i];
    }
    return sum/(double)chromo->numNodes;
}

double fadingMemory(struct chromosome *chromo, struct dataSet *data){

    int numSamples = getNumDataSetSamples(data);

    double input;
    int numNodes = 400;//getNumChromosomeNodes(chromo);

    double resultA[numSamples][numNodes];
    double resultB[numSamples][numNodes];
    double temp;
    double result = 0.0;
    double one = 1.0;

    int n;
    //printf("samples: %d, nodes: %d,\n", numSamples, numNodes);

    resetChromosome(chromo);
    n = 0;
    while(n<WARMUP) {executeChromosome(chromo, &one); n++;}
    for(int i = 0; i < numSamples; i++){

        input = getDataSetSampleInput(data, i, 0);
        //printf("A: iter:%d,input:%f\n", i, input);
        chromo = executeChromosome(chromo, &input);

        for(int j = 0; j < numNodes;j++){
            temp = getChromosomeNodeValue(chromo, j);
            //printf("%f ", result[i]);
            if(temp > 100.0 || temp < -100.0) return 1.0;
            resultA[i][j] = temp;
        }
    }

    resetChromosome(chromo);
    n = 0;
    while(n<WARMUP) {executeChromosome(chromo, &one); n++;}
    for(int i = 0; i < numSamples; i++){

        input = getDataSetSampleInput(data, i, 0);
        //invert input if i<tau
        if(i==0) {
            if(input == 1.0) input = 0.0; else input = 1.0;
        }
        //printf("B: iter:%d,input:%f\n", i, input);
        chromo = executeChromosome(chromo, &input);

        for(int j = 0; j < numNodes;j++){
            temp = getChromosomeNodeValue(chromo, j);
            //printf("%f ", result[i]);
            if(temp > 10.0 || temp < -10.0) temp = 0.0;
            resultB[i][j] = temp;
        }
    }

    for(int i = 0; i < numSamples; i++){
        for(int j = 0; j < numNodes; j++) {
            result += fabs(resultA[i][j] - resultB[i][j]);
        }
    }

    printf("result:%f\n",result);


    return result/(numNodes*numSamples);

}

double activeFitness(struct chromosome *chromo){
    return 1.0-(getNumChromosomeActiveNodes(chromo)/(double)getNumChromosomeNodes(chromo));
}

double clamp(double x, double limit){
    x = x > limit ? limit : x;
    x = x < -limit ? -limit : x;
    x = isnan(x) ? -0.0 : x;
    return x;
}