//
// Created by anderlim on 01.03.17.
//

#include "cgp.h"
#include <stdio.h>
#include <math.h>

#include "fitnessFunctions.h"

#define INF 1.0/0.0

double developmentalFitness(struct parameters *params, struct chromosome *chromo, struct dataSet *data){

    int devRuns = params->numDevRuns;
    int runs = params->numAverage;
    double sizeTarget = 200.0;
    double error,error1;
    int i,j;

    struct chromosome* currentChromo;
    const int startSize = chromo->numNodes;
    error = error1 = 0.0;

    //#pragma omp parallel for default(none), shared(chromo, runs, data, params, devRuns), private(i, currentChromo), schedule(guided), num_threads(params->numThreads), reduction(+:error)


//#pragma omp parallel for default(none), shared(chromo, runs, data, params, devRuns, sizeTarget), private(i, currentChromo), schedule(guided, runs/params->numThreads), num_threads(params->numThreads), reduction(+:error)
    //for(j = 0; j < runs; j++) {

        currentChromo = initialiseChromosomeFromChromosome(chromo);

        /* for each sample in data */
        for (i = 0; i < devRuns; i++) {
            /* calculate the chromosome outputs for the set of inputs  */
            //printf("%d, ",i);
            //printf("inpt: %d: %f\n", i,getDataSetSampleInputs(data, i)[0]);
            currentChromo = executeChromosome(currentChromo, getDataSetSampleInputs(data, i));
            //printf("%d:%f -> %f\n",i, getDataSetSampleInputs(data, i), currentChromo->nodes[1]->output);
            error += i * fabs(sizeTarget - (double) currentChromo->numNodes);
        }

        if(currentChromo->numNodes > 2*sizeTarget){// || currentChromo->numNodes == startSize){
            error += error*2;

        }

        freeChromosome(currentChromo);
    //}

//#pragma omp parallel for default(none), shared(chromo, runs, data, params, devRuns, sizeTarget), private(i, currentChromo), schedule(guided, runs/params->numThreads), num_threads(params->numThreads), reduction(+:error1)
    //for(j = 0; j < runs; j++) {

        currentChromo = initialiseChromosomeFromChromosome(chromo);

        /* for each sample in data */
        for (i = 0; i < devRuns*1.5; i++) {
            /* calculate the chromosome outputs for the set of inputs  */
            //printf("%d, ",i);
            currentChromo = executeChromosome(currentChromo, getDataSetSampleInputs(data, i));
            error1 += i * fabs(sizeTarget - (double) currentChromo->numNodes);
        }

        if(currentChromo->numNodes > 1.5 * sizeTarget || currentChromo->numNodes < 10){
            error1 += error1*2;
        }


        //freeChromosome(currentChromo);
    //}

    double fitness = max(error ,error1)/(devRuns*runs*2000.0);

    /* Save info */
    FILE *fp_size = fopen("exp11/size.txt", "a+");
    //currentChromo = initialiseChromosomeFromChromosome(chromo);
    //for(i=0; i<devRuns;i++){
        //currentChromo = executeChromosome(currentChromo, getDataSetSampleInputs(data, 0), params);
        fprintf(fp_size, "%d,%f,%d\n",currentChromo->generation, fitness, currentChromo->numNodes);
    //}
    freeChromosome(currentChromo);
    //fprintf(fp_size, "\n");
    fclose(fp_size);

    //printf("Error, %f, %f\n", error, error1);
    return fitness;

}
