//
// Created by anderlim on 22.11.16.
//
#include <unistd.h>
#include <omp.h>
#include "/usr/include/python2.7/Python.h"
#include "parityFitness.h"

#define pNAME "test"
#define pFUNC "test"

double parityFitness(int argc, char* argv[]) {

    int err = system("./run test.chr dataSets/tempParity.data 1 0 > /dev/null");

    PyObject *pName, *pModule, *pFunc, *pAvg;
    PyObject *pArgs, *pValue;
    int i;
    double result;

    if (argc < 3) {
        fprintf(stderr,"Usage: call pythonfile funcname [args]\n");
        return 1;
    }

    pName = PyString_FromString(argv[1]);
    /* Error checking of pName left out */
    pModule = PyImport_Import(pName);
    Py_DECREF(pName);

    if (pModule != NULL) {
        pFunc = PyObject_GetAttrString(pModule, argv[2]);
        /* pFunc is a new reference */
        if (pFunc && PyCallable_Check(pFunc)) {
            pArgs = PyTuple_New(argc - 3);
            for (i = 0; i < argc - 3; ++i) {
                pValue = PyInt_FromLong(atoi(argv[i + 3]));
                if (!pValue) {
                    Py_DECREF(pArgs);
                    Py_DECREF(pModule);
                    fprintf(stderr, "Cannot convert argument\n");
                    return 1;
                }
                /* pValue reference stolen here: */
                PyTuple_SetItem(pArgs, i, pValue);
            }
                // for (int i = 0; i < params) {

                pValue = PyObject_CallObject(pFunc, pArgs);

                Py_DECREF(pArgs);

                if (pValue != NULL) {
                    result = PyFloat_AsDouble(pValue);
                    //printf("Result of call: %f\n", result);
                    Py_DECREF(pValue);
                } else {
                    Py_DECREF(pFunc);
                    Py_DECREF(pModule);
                    PyErr_Print();
                    fprintf(stderr, "Call failed\n");
                    return 1;
                }
                //}
            }
        else {
            if (PyErr_Occurred())
                PyErr_Print();
            fprintf(stderr, "Cannot find function \"%s\"\n", argv[2]);
        }
        Py_XDECREF(pFunc);
        Py_DECREF(pModule);
    }
    else {
        PyErr_Print();
        fprintf(stderr, "Failed to load \"%s\"\n", argv[1]);
        return 1;
    }
    return result;
}

void parityInit(){
    Py_Initialize();
    char cmd[512], cwd[512];
    getcwd(cwd, sizeof(cwd));
    sprintf(cmd, "import sys\nsys.path.append('%s/src')", cwd);
    printf(cmd);
    PyRun_SimpleString(cmd);
}

void parityFinalize(){
    Py_Finalize();
}