from sklearn.linear_model import LogisticRegression

class ReadoutLayer():

    def __init__(self):
        self.readoutLayer = LogisticRegression(C=1.0, max_iter=1000, tol=1e-8, verbose=0, n_jobs=4)
 #       print "Readout layer initialised..."

    def train(self, trainingInput, trainingOutput):
        self.readoutLayer.fit(trainingInput, trainingOutput)
  #      print "Trained on ", len(trainingInput)

    def test(self, testInput, testOutput):
        predictions = self.readoutLayer.predict(testInput)

        #print predictions

        predictions = [1.0 if data > 0.5 else 0.0 for data in predictions]

        #print predictions
        #print len(predictions), len(testOutput)

        error = sum(predictions != testOutput)
        accuracy = 1 - float(error) / len(predictions)
        #print error, len(predictions), len(testOutput), accuracy

        return accuracy