//
// Created by anderlim on 28.09.16.
//
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include "../src/cgp.h"
#include "../gnuplot_i-2.10/src/gnuplot_i.h"

void initPlot(gnuplot_ctrl* h);

int main(int argc, char *argv[]){

    struct chromosome *chromo;
    struct dataSet *data;

    FILE *fpStates;
    fpStates = fopen("states.data", "w+");
    if(fpStates == NULL)
        printf("Error opening states.data: %d", errno);

    FILE *fpOut;
    fpOut = fopen("result.data", "w+");


    FILE *fpSize;
    fpSize = fopen("size1.data", "a+");


//    gnuplot_ctrl * h;
//    h = gnuplot_init();
//    initPlot(h);
    char *chromoFile = argv[1];
    char *dataFile = argv[2];
    int numOutputs = atoi(argv[3]);
    int debug = atoi(argv[4]);
    double chromoIn = 0.0; //, chromoInOrig = atof(argv[2]);
    int iterations, numNodes, numDataSamples;// = atoi(argv[3]);

    char *graphFilename[20];

    chromo = initialiseChromosomeFromFile(chromoFile);
    resetChromosome(chromo);
    printChromosome(chromo, 0);
    data = initialiseDataSetFromFile(dataFile);
    //printDataSet(data);

    numDataSamples = getNumDataSetSamples(data);
    numNodes = 400;//getNumChromosomeNodes(chromo);

    iterations = 1000;

    double state[iterations][numNodes];
    double chromoOut[numOutputs][iterations];


    //resetChromosome(chromo);

    for(int i = 0; i<=iterations; i++){
        //chromoIn = chromoInOrig;
        //if(i%100 == 0)
        //   chromoIn = 10.0;

        //chromoIn = getDataSetSampleInput(data, i, 0);

        fprintf(fpSize, "%d,",chromo->numNodes);

        if((i < 10 || i % 10 == 0)) {
            sprintf(graphFilename, "graph/chromoInDev_%d.dot", i);
            saveChromosomeDot(chromo, 0, graphFilename);
            printChromosome(chromo, 0);
        }

        //printf("In: %f ", chromoIn);

        //fprintf(fpOut, "%f,", chromoIn);
        //printf("Output[%2d]: [", i+1);

        for(int j = 0; j<numOutputs; j++){
            chromoOut[j][i] = getChromosomeOutput(chromo, j);
//            if(chromoOut[j][i] < -1000.0 || chromoOut[j][i] > 1000.0) {
//                chromoOut[j][i] = -0.0;
//            }
//            printf("%f\n", chromoOut[j][i]);
            fprintf(fpOut, "%f,", chromoOut[j][i]);
            //printf("%f,", chromoOut[j][i]);
        }

        fprintf(fpOut,"\n");
        //printf("]\n");

        fprintf(fpStates, "%d,", chromo->numNodes);
        for(int j = 0; j<numNodes; j++){
            fprintf(fpStates, "%f,", getChromosomeNodeValue(chromo, j));

            if(debug == 1 && j<5)printf("%f, ", getChromosomeNodeValue(chromo, j));
        }
        fprintf(fpStates, "\n");
        if(debug == 1)printf("\n");
        chromo = executeChromosome(chromo, getDataSetSampleInputs(data, i%numDataSamples));

    }


    fprintf(fpSize,"\n");


//    Plot from separate thread, fork only if numNodes > 0
//    pid_t pid = numOutputs > 0  ? fork() : -1;
//    if(pid == 0){
//        for(int i = 0; i<numOutputs; i++){
//            gnuplot_plot_x(h, chromoOut[i], iterations, "Output");
//        }
//        sleep(30);
//        _exit(EXIT_SUCCESS);
//    }


    printf("Wrote %d lines\n", iterations);
    //cleanup
    fclose(fpOut);
    fclose(fpStates);
    fclose(fpSize);
    freeChromosome(chromo);
    freeDataSet(data);

    return 0;
}

void initPlot(gnuplot_ctrl* h){
    gnuplot_setstyle(h, "steps");
    gnuplot_set_xlabel(h, "Iteration");
    gnuplot_set_ylabel(h, "Output");
}
