import matplotlib.pyplot as plot
import matplotlib.colors as colors
import numpy as np
import sys

def plotState(file, log):
    states = np.genfromtxt(file, delimiter=",")[:,1:-1]
    #states[np.isnan(states)]=0.0
    states = np.clip(states, -10000.0,10000.0)
    m = np.ma.masked_where(np.isnan(states),states)
    plot.pcolor(m)

    #f, ax = plot.subplots()
    ms = plot.matshow(states, cmap="gist_rainbow",norm=colors.SymLogNorm(0.001) if log else None)

    #cb = plot.colorbar(orientation="hotizontal", ticks=[-100.0, -1.0, -0.01, 0.0, 0.01, 1.0, 100.0], pad=0.01)

    name = "stateDiagramLog" if log else "stateDiagram"

    if(len(sys.argv) > 1):
        name = sys.argv[1]

    #plot.tight_layout()
    plot.savefig(name,dpi=200,bbox_inches='tight')

def plotOutput(file):
    res = np.genfromtxt(file, delimiter=",")[:200,:1]
    plot.plot(range(0,400),res.flatten())

    name = "Output"
    if(len(sys.argv) > 1):
        name = sys.argv[1]

    #plot.tight_layout()
    plot.savefig(name,dpi=200)


plotState("states.data", False)
plot.clf()
plotState("states.data", True)
plot.clf()
#plotOutput("result.data")